<template>
  <section class="map">
    <div class="map-wrapper">
      <GmapMap
        ref="mapRef"
        :options="map.options"
        :center="{lat: marker.lat, lng: marker.lng}"
        :zoom="map.zoom"
        class="map_goole">
        <GmapMarker
          :draggable="true"
          :clickable="true"
          :position="{ lat: marker.lat, lng: marker.lng }"
          @click="showInfoWindow"
          @dragend="emitCoordinates"/>
        <GmapInfoWindow
          :options="infoWindow.options"
          :position="{ lat: marker.lat, lng: marker.lng }"
          :opened="infoWindow.isOpen">
          <div class="kit info window">
            <span class="info-window-content">
              {{ infoWindow.content }}
            </span>
          </div>
        </GmapInfoWindow>
      </GmapMap>
    </div>
  </section>
</template>

<script>
export default {
  name: 'MapFrame',
  props: {
    address: {
      type: String,
      default: '',
    },
    position: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      marker: {
        lat: 0,
        lng: 0,
      },
      mapInstance: null,
      map: {
        options: {
          mapTypeControl: false,
          streetViewControl: false,
          clickableIcons: true,
          rotateControl: true,
          fullscreenControl: false,
          disableDoubleClickZoom: false,
          minZoom: 2,
          maxZoom: 16,
        },
        zoom: 2,
      },
      infoWindow: {
        options: {
          maxWidth: 400,
          padding: 8,
          pixelOffset: {
            width: 0,
            height: -44,
          },
        },
        position: { lat: 0, lng: 0 },
        isOpen: true,
        title: '',
        content: 'Для выбора координат переместите маркер',
      },
    };
  },
  watch: {
    address(newAddress) {
      this.geocoding(newAddress);
    },
    position(value) {
      this.setPosition(value);
    },
  },
  mounted() {
    this.initMap();
  },
  methods: {
    async initMap() {
      try {
        this.setPosition(this.position);
      } catch (e) {
        console.log(e);
      }
    },
    async geocoding(address) {
      try {
        this.mapInstance = await this.$refs.mapRef.$mapPromise;
        const geocoder = new window.google.maps.Geocoder();

        if (address) {
          geocoder.geocode({ address }, (results, status) => {
            if (status === 'OK') {
              const coordinates = {
                latLng: {
                  lat: results[0].geometry.location.lat,
                  lng: results[0].geometry.location.lng,
                },
              };

              this.mapInstance.setCenter(results[0].geometry.location);
              this.mapInstance.fitBounds(results[0].geometry.viewport);

              this.emitCoordinates(coordinates);
            }
          });
        }
      } catch (e) {
        console.log(e);
      }
    },
    reverseGeocoding(coordinates) {
      const geocoder = new window.google.maps.Geocoder();

      if (coordinates) {
        const location = {
          lat: parseFloat(coordinates.lat),
          lng: parseFloat(coordinates.lng),
        };

        geocoder.geocode({ location }, (results, status) => {
          if (status === 'OK') {
            if (results[0].formatted_address) {
              this.emitAddress(results[0].formatted_address);
            }
          }
        });
      }
    },
    showInfoWindow() {
      this.infoWindow.isOpen = true;
    },
    setMarker(coordinates) {
      this.marker = {
        lat: coordinates.lat,
        lng: coordinates.lng,
      };
    },
    setPosition(position) {
      if (position) {
        if (position.lat && position.lng) {
          this.setMarker({
            lat: position.lat,
            lng: position.lng,
          });
        } else {
          this.geocoding(position.location);
        }
      }
    },
    emitAddress(address) {
      this.$emit('set-address', address);
    },
    emitCoordinates(coordinates) {
      this.$emit('set-coordinates', {
        lat: coordinates.latLng.lat(),
        lng: coordinates.latLng.lng(),
      });

      this.$emit('set-address', '');
    },
  },
};
</script>

<style lang="scss" scoped>
  .map_goole {
    width: 100%;
    height: 300px
  }
  .map {
    position: relative;
    width: 100%;
    height: 100%;

    & > .map-wrapper {
      width: inherit;
      height: inherit;
    }

    .kit.info.window {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      overflow: auto;

      & > .info-window-content {
        color: #6a7b87;
        text-align: center;
      }
    }
  }

  .button {
    padding: 8px;
    font-size: 12px;
    border: none;
    border-radius: 3px;
    background-color: #ffdb64;
    color: #141414;
    cursor: pointer;
    outline: none;
  }
</style>
